Package org.optaplanner.core.impl.score.director.stream

## Class BavetConstraintStreamScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory<Solution_,​Score_>
  - - org.optaplanner.core.impl.score.director.stream.AbstractConstraintStreamScoreDirectorFactory<Solution_,​Score_>
    - - org.optaplanner.core.impl.score.director.stream.BavetConstraintStreamScoreDirectorFactory<Solution_,​Score_>

- All Implemented Interfaces:
    `InnerScoreDirectorFactory<Solution_,​Score_>`, `ScoreDirectorFactory<Solution_>`

      public final class BavetConstraintStreamScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>
      extends AbstractConstraintStreamScoreDirectorFactory<Solution_,​Score_>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertClonedSolution, assertionScoreDirectorFactory, initializingScoreTrend, logger, solutionDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BavetConstraintStreamScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor, ConstraintProvider constraintProvider)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `BavetConstraintStreamScoreDirector<Solution_,​Score_>` | `buildScoreDirector​(boolean lookUpEnabled, boolean constraintMatchEnabledPreference)` | Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
    `Constraint[]` | `getConstraints()` |
    `BavetConstraintSession<Solution_,​Score_>` | `newSession​(boolean constraintMatchEnabled, Solution_ workingSolution)` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.stream.AbstractConstraintStreamScoreDirectorFactory

      `buildConstraints`

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertScoreFromScratch, buildScoreDirector, getAssertionScoreDirectorFactory, getInitializingScoreTrend, getScoreDefinition, getSolutionDescriptor, isAssertClonedSolution, setAssertClonedSolution, setAssertionScoreDirectorFactory, setInitializingScoreTrend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BavetConstraintStreamScoreDirectorFactory

          public BavetConstraintStreamScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor,
                                                           ConstraintProvider constraintProvider)

  - ### Method Detail

    - #### buildScoreDirector

          public BavetConstraintStreamScoreDirector<Solution_,​Score_> buildScoreDirector​(boolean lookUpEnabled,
                                                                                               boolean constraintMatchEnabledPreference)

      Description copied from interface: `InnerScoreDirectorFactory`
      Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
      Parameters:
        `lookUpEnabled` - true if a `ScoreDirector` implementation should track all working objects for `ScoreDirector.lookUpWorkingObject(Object)`
        `constraintMatchEnabledPreference` - false if a `ScoreDirector` implementation should not do `ConstraintMatch` tracking even if it supports it.
      Returns:
        never null
      See Also:
        `InnerScoreDirector.isConstraintMatchEnabled()`, `InnerScoreDirector.getConstraintMatchTotalMap()`

    - #### newSession

          public BavetConstraintSession<Solution_,​Score_> newSession​(boolean constraintMatchEnabled,
                                                                           Solution_ workingSolution)

    - #### getConstraints

          public Constraint[] getConstraints()

      Specified by:
        `getConstraints` in class `AbstractConstraintStreamScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>`